package uniandes.teolen.automatas.mundoAutomata;

import java.util.*;

public abstract class Automata {
	
	String inputTape;
	StringBuffer outputTape = new StringBuffer();
	State currentState;
	States states;
	ArrayList  <State> finalStates ;
	State inic;
	int tapePos;
	
	
	protected Automata(){
	}
	
	protected void initializeAutomata(States myStates, State myStartState, ArrayList <State> myFinalStates ) {
		states = myStates;
		inic=myStartState;
		finalStates = myFinalStates;
	}

	public void setInput(String inputString) {
		inputTape = inputString;
	}
	
	private void processSymbol() throws Exception {
		outputTape.append(transitionOutput(currentState,inputTape.charAt(tapePos)));
		currentState = delta(currentState,inputTape.charAt(tapePos));
		if (!states.has(currentState)) {
			throw new Exception("Estado inexistente: " + currentState);
		}
		outputTape.append(stateOutput(currentState));
		tapePos++;
	}
	
	public boolean processString() throws Exception
	{	
		tapePos = 0;
		currentState = inic;
		outputTape = new StringBuffer();
		outputTape.append(stateOutput(currentState));
		
		while (tapePos < inputTape.length()) {
			processSymbol();
		}
		return finalStates.contains(currentState) && tapePos==inputTape.length();
	 }
 
   protected  abstract State delta(State s, char c) throws Exception;
  
   
   protected  String stateOutput(State s) {
	   return new String();
   }
   
   protected String transitionOutput(State s, char c){
	   return new String(""+c);
   }
  
   public String getOutput(){
	  return outputTape.toString();
  }

   protected State s(Object ... a)
   {
	   return  StateFactory.s(a);
   }

 
   public String toString() {
	   return "Automata:  ?";
   }

  
}

   



