package uniandes.teolen.automatas.mundoAutomata;

import java.util.*;

public class MundoAutomatas {
	
	// Automatas no parametrizados
	private  ArrayList  <Automata> autos  = new ArrayList <Automata> (); 
    
	// Nombres de los autmatas parametrizados
	private  ArrayList  <String> autosP  = new ArrayList <String> (); 
	
	// Autmata que se est usando
	private  Automata currentAuto;
	
	
	public  MundoAutomatas () {
	
		// Agreguen al final de esta lista los nuevos autmatas no parametrizados
		
		autos.add(new VerificadorParidad());
		autos.add(new ContadorModuloN(3));
		autos.add( new HasCat());
		autos.add( new Taller2());
		autos.add( new Petri1());
		autos.add( new Petri2());
		autos.add(  new Quiz());
		autos.add( new EjemploAGCT());
  	
		// Agreguen al final de esta lista los nombres de los nuevos autmatas parametrizados
		
	    autosP.add("Contador Modulo N");
	    autosP.add("Dividir por  N");
	    autosP.add("Cifrar por N");
	    
	    currentAuto =  autos.get(0);

	}
	
	public Automata getAutoP(int a, int p) {
	
		// Agregue en el orden de los nombres  el llamado al constructor del autmata correspondiente
		
		switch (a)  {
		  case 0: return new ContadorModuloN(p);
		  case 1: return new DivPorN(p);
		  case 2: return new FraseAceptable(p);
		}

		return currentAuto;	
	
	
	}
	
	public Automata getCurrentAuto() {
		return currentAuto;
	}
	
	
	public void setCurrentAuto(Automata a) {
		currentAuto = a;
	}
	
	public Automata getAuto(int i) {
		return autos.get(i);
	}
	
	
	public String getAutoP(int i) {
		return autosP.get(i);
	}
	
	public int sizeAutos() {
		return autos.size();
	}
	
	public int sizeAutosP() {
		return autosP.size();
	}
	
	public String  procesarCadena(String texto) {
		String resp;
		
		currentAuto.setInput(texto);
		try {
			if (currentAuto.processString())
				resp = "Auto "+ currentAuto+ " Acepto la cadena: "+texto;
			else
				resp = "Auto "+ currentAuto + " No Acepto la cadena: "+texto;
			resp= resp + "\n Respuesta: " + currentAuto.getOutput();		
		}
		catch (Exception e)
		{
			resp = "ERROR "+ currentAuto;
			e.printStackTrace() ;
		}
		return resp;
	}

}
