package uniandes.teolen.automatas.mundoAutomata;

import java.util.ArrayList;

// autmata : Taller2
// Acepta mensajes en los cuales la i-esima palabra (con i mltiplo de 5) 
// del mensaje debe ser cat. 
//  Solo acepta letras minsculas,los signos de puntuacin y el espacio.
//  Despus de cada punto le agrega el nmero de palabras mdulo 5 que ha leido
// Slo acepta un punto entre palabras.

// State.s(x,y) 
//     el valor de x indica que ha leido n palabras con n%5 = x 
//     el valor de y indica lo siguiente: 
//       -1: lo ltimo que ley fue un blanco, 
//       -2: lo ltimo que ley fue un separador, 
//        0: est leyendo  caracteres de la n-sima palabra donde  n%5 = x+1 .
//  si x es igual a 4 se tienen otros vlaores de y usados para leer cat
//		   0: ley c
//		   1: ya ha leido ca
//		   2: se ley cat 	
// El autmata acepta un espacio despus de un signo de puntacin. Tambin acepta uso de
// signos de puntuacin como separadores sin espacio. No acepta signos de puntacin despes de 
// un espacio (antes de la siguiente palabra.
// admite terminar en un espacio.
// No admite comenzar con espacio ni con signo de puntuacion.
		
public class Taller2 extends Automata {
	
	// se definen constantes para algunos estados para facilitar su uso
	
	 final State find_cat2 = s(4,-2);
	 final State find_cat1 = s(4,-1);	
	 final State find_c_at = s(4,0);
	 final State find_ca_t = s(4,1);
	 final State found_cat = s(4,2);
	 final State err = s(-1,-1);
	
	

		
	public Taller2()
	{
		super();
	
	
		States myStates = new States() ;
	
		ArrayList <State> myFinalStates = new ArrayList <State> ();
	
		State myStartState;
	  
		for (int i=0; i < 5; i++) { 
			for (int j=-2; j <= 0; j++) { 
				   myStates.storeState(s(i,j));
			   }
		}	
		
		myStates.storeState(find_cat1);
		myStates.storeState(find_cat2);
		myStates.storeState(find_c_at);
		myStates.storeState(find_ca_t);
		myStates.storeState(found_cat);
	   	myStates.storeState(err);
		
		
		for (int i=0; i < 4; i++) { 
			for (int j=-2; j <= 0; j++) { 
				   myFinalStates.add(s(i,j));
			   }
		}	
		
			
		myFinalStates.add(found_cat);
		myFinalStates.add(find_cat1); // aun no ha empezado a leer la (x
		myFinalStates.add(find_cat2);
		
		myStartState = s(0,-1);
	
		
	
		initializeAutomata(myStates,myStartState,myFinalStates);
	}
	
	boolean isSeparador(char c){
		return  (c == '.') || (c == ',') || (c == ':') || (c == ';') || (c == '?') || (c == '!');  
	}
	
	protected   State delta(State s, char c) throws Exception {
		
		State result = err;

		if (s!=err) {		
			if (s == find_cat1 || s == find_cat2 ){
				if (c == 'c') 
					result =  find_c_at;
				else if (c == ' ' && s == find_cat2)
					result = find_cat1;
			}		  
			else if (s == find_c_at)	  
			{
				if (c == 'a')
					result = find_ca_t;
				}
			else if (s == find_ca_t)	 {
				if (c == 't')
					result = found_cat;
				}	
			else if (s == found_cat) {
				if ( c == ' ')
					result = s(0,-1);
				else if (isSeparador(c))
					result = s(0,-2);
				}
			else {
				int v = (Integer) s.nTh(1);
				if ( v == 0) {
					if (('a' <= c && c <= 'z') || ('a' <= c && c <= 'z'))
						result = s;
					else if (c == ' ')
						result = s((Integer) s.nTh(0)+1,-1);
					else if (isSeparador(c))
						result = s((Integer) s.nTh(0)+1,-2);
					
				}	
				else if ( v == -1) {
					if (('a' <= c && c <= 'z') || ('a' <= c && c <= 'z'))
						result = s((Integer) s.nTh(0),0);
				}
				else if ( v == -2) {
					if (('a' <= c && c <= 'z') || ('a' <= c && c <= 'z'))
						result = s((Integer) s.nTh(0),0);
					else if (c == ' ')
						result = s((Integer) s.nTh(0),-1);
				}
			}	
		}
		return result;
				
	}
	
	protected String transitionOutput(State s, char c){
		
		if ( s == err)
			return new String();
		else if (c != '.') {
			return new String(c+"");
		}
		else return new String("."+((Integer)s.nTh(0)+1)%5);
	}
	
	 public String toString() {
		   return "Taller2";
	   }
}
	
